package adriver{

	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.display.Shape;
	import flash.external.ExternalInterface;
	import flash.events.*;
	import flash.net.navigateToURL;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.utils.*;

	public class multiLoader extends Loader{
		private var showInterval:Number = 6500;
		private var maxBn:Number = 1;
		private var bn:Number = 0;
		private var busy:Boolean = false;
		private var req:String = 'http://ad.adriver.ru/cgi-bin/xmerle.cgi?bt=54&rnd=![rnd]&bn=';
		private var inPause:Boolean;
		private var timer:Number;
		private var now:Number;
		private var _stage;
		private var btn:SimpleButton;
		private var mov:MovieClip;
		private var roller:MovieClip;
		private var pauseButton:MovieClip;
		private var link1:String = '';
		private var params:String = '';

		private var banners:Array = [];

		function multiLoader(target:MovieClip, roll:MovieClip, b:SimpleButton, p:MovieClip){
			super();

			mov = target;
			roller = roll;
			btn = b;
			pauseButton = p;
			_stage = mov.root;

			maxBn = parseInt(flashVars('count')) || maxBn;
			showInterval = parseInt(flashVars('interval')) || showInterval;
			params = flashVars('params');
			
			if (!params) return;
			
			btn.addEventListener(MouseEvent.CLICK, click);
			btn.addEventListener(MouseEvent.MOUSE_OVER, pause);
			btn.addEventListener(MouseEvent.MOUSE_OUT, resume);

			contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, on_error);
			contentLoaderInfo.addEventListener(SecurityErrorEvent.SECURITY_ERROR, on_error);
			contentLoaderInfo.addEventListener(Event.INIT, showRoll);

			mov.addChild(this);

			resume(null);
		}

		public function showComplete():void {
			busy = false;
			if (!inPause) {
				timer = setTimeout(loadNext, showInterval);
				now = new Date().getTime();
			}
		}
		public function hideComplete():void {
			if (banners[bn].src != '')
				load(new URLRequest(banners[bn].src));
			else
				showRoll();

			link1 = banners[bn].link1;
		}

		private function loadNext():void {
			if (!busy) busy = true;
			else return;
			
			now = new Date().getTime();

			bn++;
			if (bn>maxBn) bn = 1;
			
			if (banners[bn]) hideRoll();
			else new getObjectFromXML(req + bn + '&' + params, onLoadXML);
		}
		private function onLoadXML(o:Object):void {
			banners[bn] = {
				src: o.swf || o.image || '',
				link1: o.ar_cgihref
			}

			o.sendPixel(o.pixel1);
			o.sendPixel(o.pixel2);

			hideRoll();
		}
		private function showRoll(e:Event = null):void {
			roller.gotoAndPlay('show');
		}
		private function hideRoll():void {
			roller.gotoAndPlay('hide');
		}
		private function click(e:MouseEvent):void {
			try {
				var ie:String = ExternalInterface.call("function(){return !!window.ActiveXObject}");
				if(ie)ExternalInterface.call('window.open', link1);
				else navigateToURL(new URLRequest(link1), '_blank');
			}catch (e:Error){
				navigateToURL(new URLRequest(link1), '_blank');
			}
		}
		private function pause(e:Event):void {
			clearTimeout(timer);
			inPause = true;
			pauseButton.visible = true;
		}
		private function resume(e:Event):void {
			inPause = false;
			pauseButton.visible = false;

			var temp = new Date().getTime();
			if (showInterval - temp + now > 0) timer = setTimeout(loadNext, showInterval - temp + now);
			else loadNext();
		}
		private function flashVars(name:String):String {
			return _stage.loaderInfo.parameters[name] || '';
		}

		private function on_error(e:Event):void {
			trace(e);
			busy = false;
		}
	}
}